import { QueryFunction, QueryFunctionContext, QueryKey } from '@tanstack/vue-query';
import { AppRoute, AppRouteMutation, ClientArgs, ClientInferRequest, ClientInferResponses, ErrorHttpStatusCode, SuccessfulHttpStatusCode } from '@ts-rest/core';
export type DataResponse<TAppRoute extends AppRoute> = ClientInferResponses<TAppRoute, SuccessfulHttpStatusCode, 'force'>;
export type ErrorResponse<TAppRoute extends AppRoute> = ClientInferResponses<TAppRoute, ErrorHttpStatusCode, 'ignore'>;
export declare const queryFn: <TAppRoute extends AppRoute, TClientArgs extends ClientArgs>(route: TAppRoute, clientArgs: TClientArgs, argsMapper?: {
    query: any;
    headers: {
        [x: Lowercase<string>]: any;
    };
    body: any;
    cache?: RequestCache | undefined;
    fetchOptions?: Omit<RequestInit, "headers" | "method" | "body"> | undefined;
    params: {
        [x: string]: any;
    };
    extraHeaders?: ({
        [x: Lowercase<string>]: undefined;
    } & Record<string, string | undefined>) | undefined;
    overrideClientOptions?: Partial<import("@ts-rest/core").OverrideableClientArgs> | undefined;
} | ((context: QueryFunctionContext<QueryKey>) => ClientInferRequest<AppRouteMutation, ClientArgs>) | undefined) => QueryFunction<ClientInferResponses<TAppRoute, SuccessfulHttpStatusCode, "force">>;
