import type { QueryFunctionContext, QueryKey, UseInfiniteQueryOptions, UseInfiniteQueryReturnType } from '@tanstack/vue-query';
import { AppRoute, AppRouteMutation, ClientArgs, ClientInferRequest, PartialClientInferRequest } from '@ts-rest/core';
import { DataResponse, ErrorResponse } from './common';
export type DataReturnInfiniteQuery<TAppRoute extends AppRoute, TClientArgs extends ClientArgs> = <TData = DataResponse<TAppRoute>>(queryKey: QueryKey, args: (context: QueryFunctionContext) => PartialClientInferRequest<TAppRoute, TClientArgs>, options?: UseInfiniteQueryOptions<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>, TData>) => UseInfiniteQueryReturnType<TData, ErrorResponse<TAppRoute>>;
export declare const getRouteUseInfiniteQuery: <TAppRoute extends AppRoute, TClientArgs extends ClientArgs>(route: TAppRoute, clientArgs: TClientArgs) => (queryKey: QueryKey, argsMapper: (context: QueryFunctionContext) => ClientInferRequest<AppRouteMutation, ClientArgs>, options?: UseInfiniteQueryOptions<DataResponse<TAppRoute>> | undefined) => UseInfiniteQueryReturnType<DataResponse<TAppRoute>, unknown>;
