import type { MutationOptions, UseMutationReturnType } from '@tanstack/vue-query';
import { AppRoute, ClientArgs, PartialClientInferRequest } from '@ts-rest/core';
import { DataResponse, ErrorResponse } from './common';
export type DataReturnMutation<TAppRoute extends AppRoute, TClientArgs extends ClientArgs> = (options?: MutationOptions<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>, PartialClientInferRequest<TAppRoute, TClientArgs>, unknown>) => UseMutationReturnType<DataResponse<TAppRoute>, ErrorResponse<TAppRoute>, PartialClientInferRequest<TAppRoute, TClientArgs>, unknown>;
export declare const getRouteUseMutation: <TAppRoute extends AppRoute, TClientArgs extends ClientArgs>(route: TAppRoute, clientArgs: TClientArgs) => (options?: MutationOptions<TAppRoute["responses"], unknown, void, unknown> | undefined) => UseMutationReturnType<TAppRoute["responses"], unknown, void, unknown, Omit<import("@tanstack/vue-query").MutationObserverIdleResult<TAppRoute["responses"], unknown, void, unknown>, "mutate" | "reset"> | Omit<import("@tanstack/vue-query").MutationObserverLoadingResult<TAppRoute["responses"], unknown, void, unknown>, "mutate" | "reset"> | Omit<import("@tanstack/vue-query").MutationObserverErrorResult<TAppRoute["responses"], unknown, void, unknown>, "mutate" | "reset"> | Omit<import("@tanstack/vue-query").MutationObserverSuccessResult<TAppRoute["responses"], unknown, void, unknown>, "mutate" | "reset">>;
