import { AppRoute, AppRouteFunction, AppRouteMutation, AppRouteQuery, AppRouter, ClientArgs, Without } from '@ts-rest/core';
import { DataReturnQuery } from './use-query';
import { DataReturnInfiniteQuery } from './use-infinite-query';
import { DataReturnMutation } from './use-mutation';
type UseQueryArgs<TAppRoute extends AppRoute, TClientArgs extends ClientArgs> = {
    useQuery: TAppRoute extends AppRouteQuery ? DataReturnQuery<TAppRoute, TClientArgs> : never;
    useInfiniteQuery: TAppRoute extends AppRouteQuery ? DataReturnInfiniteQuery<TAppRoute, TClientArgs> : never;
    query: TAppRoute extends AppRouteQuery ? AppRouteFunction<TAppRoute, TClientArgs> : never;
    useMutation: TAppRoute extends AppRouteMutation ? DataReturnMutation<TAppRoute, TClientArgs> : never;
    mutation: TAppRoute extends AppRouteMutation ? AppRouteFunction<TAppRoute, TClientArgs> : never;
};
type RecursiveProxyObj<T extends AppRouter, TClientArgs extends ClientArgs> = {
    [TKey in keyof T]: T[TKey] extends AppRoute ? Without<UseQueryArgs<T[TKey], TClientArgs>, never> : T[TKey] extends AppRouter ? RecursiveProxyObj<T[TKey], TClientArgs> : never;
};
/** @deprecated Use `TsRestVueQueryClient` instead */
export type InitClientReturn<T extends AppRouter, TClientArgs extends ClientArgs> = TsRestVueQueryClient<T, TClientArgs>;
export type TsRestVueQueryClient<T extends AppRouter, TClientArgs extends ClientArgs> = RecursiveProxyObj<T, TClientArgs>;
export declare const initQueryClient: <T extends AppRouter, TClientArgs extends ClientArgs>(router: T, args: TClientArgs) => RecursiveProxyObj<T, TClientArgs>;
export {};
